<?php // no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

// This function outputs each menu item:

/**
 * Outputs one level of categories and calls itself for any subcategories
 *
 * @access	public
 * @param int $catPId (the category_id of current parent category)
 * @param int $level (the current category level [main cats are 0, 1st subcats are 1])
 * @param object $params (the params object containing all params for this module)
 * @param int $currentCat (category_id from the request array, if it exists)
 * @return nothing - echos html directly
 **/
// Because this function is declared in the view, need to make sure it hasn't already been declared:
if (!function_exists('vmFCLBuildMenu')) {
	function vmFCLBuildMenu($catPId = 0, $level = 0, $params, $currentCat = null) {
		// prepare params:
		$levelStart = (int) $params->get('level_start');
		$levelEnd = (int) $params->get('level_end');
		$menuClass = $params->get('menuclass_sfx');
	
		// Check for category_id (to figure out current category, if applicable):
		if ($currentCat === null)  $currentCat = JRequest::getInt('category_id', -1);

		if ( (!$levelEnd || $level < $levelEnd) && $rows = modVMFullCategoryList::vmFCLGetCatSiblings($catPId, $params) ) {
			if ($level >= $levelStart) : ?>
			<ul class="level<?php echo $level . $menuClass ?>">
			<?php endif;
			foreach( $rows as $row ) {
				if ($level >= $levelStart) :
					$itemid = modVMFullCategoryList::vmFCLGetVMItemId($row->category_id);
					$itemid = ($itemid ? '&Itemid='.$itemid : '');
					$link =	JFilterOutput::ampReplace(JRoute::_('index.php?option=com_virtuemart'
							.'&page=shop.browse&category_id='.$row->category_id . $itemid ));
					?>
					<li<?php echo ($currentCat == $row->category_id ? ' id="current"' : '') ?>>
						<a class="level<?php echo $level . $menuClass . ($currentCat == $row->category_id ? ' active' : '') ?>" href="<?php echo $link ?>" target="_self">
						<?php echo htmlspecialchars($row->category_name, ENT_COMPAT, 'UTF-8') ?></a>
				<?php endif;
				// Check for sub categories
				vmFCLBuildMenu($row->category_id, $level + 1, $params, $currentCat);
				if ($level >= $levelStart) : ?>
				</li>
			<?php endif;
			} // end foreach
			if ($level >= $levelStart) : ?>
			</ul>
			<?php endif;
		}
	}
}
// Call the function for the first menu item:
vmFCLBuildMenu(0, 0, $params);

// Are there any better ways to make this follow joomla's MVC pattern
// (by outputting a tree structure returned by helper class, for ex)? like:
// while ($item) {
	// output
	// $item = $item->child;
//}
// Probably way out of the scope of this module...
// see mod_mainmenu if you don't believe it
?>
